/*
 * Copyright
 *   2007 axYus - www.axyus.com
 *
 * This file is part of XEMELIOS.
 *
 * XEMELIOS is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * XEMELIOS is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with XEMELIOS; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package fr.gouv.finances.cp.xemelios.controls.pesv2.comm;

import java.util.Hashtable;
import java.util.Vector;

import org.apache.log4j.Logger;
import org.xml.sax.Attributes;
import org.xml.sax.Locator;
import org.xml.sax.SAXException;

import fr.gouv.finances.cp.xemelios.controls.AbstractUnitControl;
import fr.gouv.finances.cp.xemelios.controls.Anomalie;
import fr.gouv.finances.cp.xemelios.controls.IdGenerator;
import fr.gouv.finances.cp.xemelios.controls.Node;
import fr.gouv.finances.cp.xemelios.controls.pesv2.ConstantsControlsPESv2;

/**
 * Implémente le contrôle N° COMM05B - Contrôle de la présence d'un identifiant de collectivité - Contrôle du fichier
 * Il consiste à vérifier la règle fonctionnelle suivante :
 * 		1)	L’ensemble des balises IdPost, IdColl, CodCol, CodBud doivent être valorisés et correspondre aux Paramètres définis
 * (IdPost pour PAR3, IdColl pour PAR4, CodCol pour PAR5, CodBud pour PAR6). Dans le cas contraire générer les ANOMALIES BLOQUANTES suivantes.
 * Si IdPost est vide ou ne correspond pas à PAR3 « Le codique du poste doit être renseigné et correspondre au paramétrage ». 
 * Si IdColl est vide ou ne correspond pas à PAR4 « le SIRET de la collectivité doit être valorisé et correspondre au paramétrage». 
 * Si IdColl est vide ou ne correspond pas à PAR5 :  « le code collectivité doit être valorisé  et correspondre au paramétrage ». 
 * Si IdBud est vide ou ne correspond pas à PAR6 « le code budget doit être valorisé et correspondre au paramétrage». 
 * Si Aucune balise n’est présente (IdPost, IdColl, CodColl, CodBud) alors générer une ANOMALIE BLOQUANTE « la collectivité doit être identifiée »
 * 		2)	La balise IdPost doit correspondre à PAR3. Dans le cas contraire générer une ANOMALIE BLOQUANTE : « Le codique du poste est différent du paramétrage :
 * il doit comprendre au minimum 6
 * caractères SANS espace »
 * 		3)	La balise IdColl doit correspondre à PAR4. Dans le cas contraire générer une ANOMALIE BLOQUANTE « Le n° SIRET de la collectivité doit être valide et
 * correspondre au paramétrage. Il comporte 14 caractères numériques»
 * 		4)	La balise CodColl doit correspondre à PAR5. Dans le cas contraire générer une ANOMALIE BLOQUANTE : « Le Code collectivité doit être valide et correspondre
 * au paramétrage. Il comporte 3 caractères alphanumériques SANS espaces »
 * 		5)	La balise CodBud doit correspondre à PAR6. Dans le cas contraire générer une ANOMALIE BLOQUANTE : « Le Code budget doit être valide et correspondre au paramétrage.
 * Il comprend 2 caractères alphanumériques SANS espaces »
 */

public class COMM05B extends AbstractUnitControl implements ConstantsControlsPESv2 {
	private final static Logger logger = Logger.getLogger(COMM05B.class);
    public static final transient String CTRL_ID = "COMM05B";
	private Vector<Anomalie> anos = new Vector<Anomalie>();
	private Hashtable<String,Object> hParams;
	
	private String docId = null;
	
	/**
	 * La chaine cible
	 */
	private static final String CHEMIN_FIN = "PES_Aller/";
	private static final String ON_RETURN_ANOMALIES = "/Bordereau/";
	
	/**
	 * Variables contenant les valeurs nécessaires à ce contrôle
	 */
	private String PAR3 = "";
	private String PAR4 = "";
	private String PAR5 = "";
	private String PAR6 = "";

	private String bord_Exer = "";
	private String bord_IdBord = "";
	private String bord_TypBord = "";
	
	private String idPost = "";
	private String idCol = "";
	private String codCol = "";
	private String codBud = "";
	private String idPost_NodeId = "";
	private String idCol_NodeId = "";
	private String codCol_NodeId = "";
	private String codBud_NodeId = "";

	private boolean idPost_present = false;
	private boolean idCol_present = false;
	private boolean codCol_present = false;
	private boolean codBud_present = false;
	
	private boolean first_bordereau = false;
	
	/**
	 * Variables devant être remplacées dans le message
	 */

	private static final String MSG_ERREUR = "#ERREUR#";
	
	/**
	 * Chemins incomplet vers les divers éléments que l'on veux lire. Ils sont incomplets dans la mesure 
	 * où on n'a pas le début du chemin, vu que ce contrôle est utilisé pour les Dépenses et les Recettes
	 */
	private static final String RECETTE = "PES_RecetteAller";
	private static final String DEPENSE = "PES_DepenseAller";
	private boolean depense = false;

	private static final String CHEMIN_BLOCBORDEREAU = "/Bordereau/BlocBordereau/";
	private static final String CHEMIN_BLOCBORDEREAU_EXER = "/Bordereau/BlocBordereau/Exer/";
	private static final String CHEMIN_BLOCBORDEREAU_IDBORD = "/Bordereau/BlocBordereau/IdBord/";
	private static final String CHEMIN_BLOCBORDEREAU_TYPBORD = "/Bordereau/BlocBordereau/TypBord/";
	
	private static final String CHEMIN_ENTETE = "/EnTetePES/";
	private static final String CHEMIN_CODIQUE = "/EnTetePES/IdPost/";
	private static final String CHEMIN_SIRET = "/EnTetePES/IdColl/";
	private static final String CHEMIN_CODCOL = "/EnTetePES/CodCol/";
	private static final String CHEMIN_CODBUB = "/EnTetePES/CodBud/";
	
	
	public void startDocument() throws SAXException {
		logger.info("In "+CTRL_ID);
	}
	
	public void setDocId(String docID) {
		this.docId = docID;		
	}

	public void startElement(String uri, String localName, String qName,Attributes atts, String xpath) {
		// RECETTE ou DEPENSE
		if (xpath.indexOf(DEPENSE)!=-1) {
			depense = true;
		}
		if (xpath.indexOf(RECETTE)!=-1) {
			depense = false;
		}
		if (xpath.endsWith(CHEMIN_CODIQUE)) {
			idPost = atts.getValue("V");
			idPost_NodeId = atts.getValue("ano:node-id");
			idPost_present = true;
		}
		if (xpath.endsWith(CHEMIN_SIRET)) {
			idCol = atts.getValue("V");
			idCol_NodeId = atts.getValue("ano:node-id");
			idCol_present = true;
		}
		if (xpath.endsWith(CHEMIN_CODCOL)) {
			codCol = atts.getValue("V");
			codCol_NodeId = atts.getValue("ano:node-id");
			codCol_present = true;
		}
		if (xpath.endsWith(CHEMIN_CODBUB)) {
			codBud = atts.getValue("V");
			codBud_NodeId = atts.getValue("ano:node-id");
			codBud_present = true;
		}
		if (!first_bordereau){
			if (xpath.endsWith(CHEMIN_BLOCBORDEREAU)) {
				bord_Exer = bord_IdBord = bord_TypBord = "";			
			}
			if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_EXER)) {
				bord_Exer = atts.getValue("V");
			}
			if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_IDBORD)) {
				bord_IdBord = atts.getValue("V");
			}
			if (xpath.endsWith(CHEMIN_BLOCBORDEREAU_TYPBORD)) {
				bord_TypBord = atts.getValue("V");
				first_bordereau = true;		
			}
		}
	}
	

	public Vector<Anomalie> endElement(String uri, String localName, String qName, String xpath) throws SAXException {
		boolean oneTime = false;
		
		if(!oneTime && xpath.endsWith(ON_RETURN_ANOMALIES)){
			oneTime = true;
			
			if (hParams.get("idPost")!=null) 
				PAR3 = (String)hParams.get("idPost");
			if (hParams.get("idColl")!=null) 
				PAR4 = (String)hParams.get("idColl");
			if (hParams.get("codCol")!=null) 
				PAR5 = (String)hParams.get("codCol");
			if (hParams.get("codBud")!=null) 
				PAR6 = (String)hParams.get("codBud");
			
			String erreur = "";

			
			if (!idPost_present || !idPost.equals(PAR3) || idPost.equals("")) {
				erreur = "Codique = " + idPost + " _ Paramètre codique = " + PAR3 + " : Le codique du poste doit être renseigné et correspondre au paramétrage.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(idPost_NodeId));
				anos.add(ano);
			}
			if (!idCol_present || !idCol.equals(PAR4) || idCol.equals("")) {
				erreur = "SIRET = " + idCol + " _ Paramètre SIRET = " + PAR4 + " : Le SIRET de la collectivité doit être valorisé et correspondre au paramétrage.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(idCol_NodeId));
				anos.add(ano);
			}
			if (!codCol_present || !codCol.equals(PAR5) || codCol.equals("")) {
				erreur = "Code collectivité = " + codCol + " _ Paramètre code collectivité = " + PAR5 + " : Le code collectivité doit être valorisé et correspondre au paramétrage.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(codCol_NodeId));
				anos.add(ano);
			}
			if (!codBud_present || !codBud.equals(PAR6) || codBud.equals("")) {
				erreur = "Code budget = " + codBud + " _ Paramètre code budget = " + PAR6 + " : Le code budget doit être valorisé et correspondre au paramétrage.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(codBud_NodeId));
				anos.add(ano);
			}
			if (!idPost_present && !idCol_present && !codCol_present && !codBud_present) {
				erreur = "La collectivité doit être identifiée.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				anos.add(ano);
			}
			if (!idPost.matches("^[0-9a-zA-Z]{6}$")) {
				erreur = "Codique = " + idPost + " : Le codique du poste doit être composé de 6 caractères SANS espace.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(idPost_NodeId));
				anos.add(ano);
			}
			if (!idCol.matches("^[0-9]{14}$")) {
				erreur = "SIRET = " + idCol + " : Le n° SIRET doit être composé de 14 caractères numériques.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(idCol_NodeId));
				anos.add(ano);
			}
			if (!codCol.matches("^[0-9a-zA-Z]{3}$")) {
				erreur = "Code collectivité = " + codCol + " : Le code collectivité doit être composé de 3 caractères alphanumériques SANS espace.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(codCol_NodeId));
				anos.add(ano);
			}
			if (!codBud.matches("^[0-9a-zA-Z]{2}$")) {
				erreur = "Code budget = " + codBud + " : Le code budget doit être composé de 2 caractères alphanumériques SANS espace.";
				
				String msg = getDocumentModel().getControlById(CTRL_ID).getMessage().getHtmlContent();
				msg = msg.replaceAll(MSG_ERREUR, erreur);

				String path="@added:primary-key='"+bord_Exer+"-"+bord_TypBord+"-"+bord_IdBord+"'";
				String anoId = IdGenerator.nextId();
				String libelleLien = "Bordereau "+bord_IdBord;
				Hashtable<String, Object> xslParams = new Hashtable<String, Object>();
				xslParams.put("elementId", "Bordereau");
				xslParams.put("mandatId", "");
				xslParams.put("browser-destination", "internal");
				xslParams.put("anoId", anoId);
				Anomalie ano = new Anomalie(anoId,
                                        getDocumentModel().getControlById(CTRL_ID).getId(),
                                        getDocumentModel().getControlById(CTRL_ID).getLibelle(),
                                        getDocumentModel().getDocumentId(),
                                        (depense?DEPENSE:RECETTE),
                                        (depense?BORDEREAU_DEPENSE:BORDEREAU_RECETTE), // élément importable
                                        bord_IdBord, // id élément importable
                                        localName,
                                        libelleLien,
                                        msg,
                                        getDocumentModel().getControlById(CTRL_ID).getRegle().getHtmlContent(),
                                        getDocumentModel().getControlById(CTRL_ID).getSeverity(),
                                        path,
                                        xslParams);
				ano.addNode(new Node(codBud_NodeId));
				anos.add(ano);
			}
			return anos;
		} else {
			return null;
		}
	}

	public void endDocument() throws SAXException {}
	
	public void characters(char[] ch, int start, int length, String xpath) {}
	
	public void ignorableWhitespace(char[] ch, int start, int length,String xpath) {}
	
	public void startPrefixMapping(String prefix, String uri, String xpath) {}
	
	public void endPrefixMapping(String prefix, String xpath) {}
	
	public void processingInstruction(String target, String data, String xpath) {}
	
	public void skippedEntity(String name, String xpath) {}
	
	public void setParameters(Hashtable<String,Object> params) {
		this.hParams=params;
	}
	
	public void setDocumentLocator(Locator locator) {}
}
